Loading...
Searching...
No Matches
Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R > Class Template Reference
Functions » Function implementations

A grid function induced by a global basis and a coefficient vector. More...

`#include <dune/functions/gridfunctions/discreteglobalbasisfunction.hh>`

Inheritance diagram for Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >:

## Classes

class | LocalFunction

## Public Types

using | Basis = typename Base::Basis
using | Vector = typename Base::Vector
using | Domain = typename Base::Domain
using | Range = R
using | Traits = Imp::GridFunctionTraits<Range(Domain), typename Base::EntitySet, DefaultDerivativeTraits, 16>
using | Coefficient
using | GridView
using | EntitySet
using | Tree
using | NodeToRangeEntry
using | LocalDomain
using | Element

## Public Member Functions

template<class B_T, class V_T, class NTRE_T>
| DiscreteGlobalBasisFunction (B_T &&basis, V_T &&coefficients, NTRE_T &&nodeToRangeEntry)
| Create a grid-function, by wrapping the arguments in std::shared_ptr.
| DiscreteGlobalBasisFunction (std::shared_ptr< const Basis > basis, std::shared_ptr< const V > coefficients, std::shared_ptr< const typename Base::NodeToRangeEntry > nodeToRangeEntry)
| Create a grid-function, by moving the arguments in std::shared_ptr.
Range | operator() (const Domain &x) const
| Evaluate at a point given in world coordinates.
const Basis & | basis () const
| Return a const reference to the stored basis.
const Vector & | dofs () const
| Return the coefficients of this discrete function by reference.
const NodeToRangeEntry & | nodeToRangeEntry () const
| Return the stored node-to-range map.
const EntitySet & | entitySet () const
| Get associated set of entities the local-function can be bound to.

## Protected Attributes

std::shared_ptr< const Data > | data_

## Friends

DiscreteGlobalBasisFunctionDerivative< DiscreteGlobalBasisFunction > | derivative (const DiscreteGlobalBasisFunction &f)
| Derivative of the DiscreteGlobalBasisFunction.
LocalFunction | localFunction (const DiscreteGlobalBasisFunction &t)
| Construct local function from a DiscreteGlobalBasisFunction.

## Related Symbols

(Note that these are not member symbols.)
template<typename R, typename B, typename V>
auto | makeDiscreteGlobalBasisFunction (B &&basis, V &&vector)
| Generate a DiscreteGlobalBasisFunction.

## Detailed Description

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>
class Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >

A grid function induced by a global basis and a coefficient vector.

This implements the grid function interface by combining a given global basis and a coefficient vector.

This class supports mapping of subtrees to multi-component ranges, vector-valued shape functions, and implicit product spaces given by vector-valued coefficients. The mapping of these to the range type is done via the following multistage procedure:

1.Each leaf node in the local ansatz subtree is associated to an entry RE of the range-type via the given node-to-range-entry-map. Based on this mapping each node is processed independently in the following way:

2.Now let the coefficients type C per basis function be dim_C-dimensional. Then we compute the dim(C) linear combinations (one for each coefficient index) of the shape function values with type V independently storing them in a std::array<V,dim_C>.

3.Finally the resulting array of function values is assigned to the nodal range entry RE. Since both types may be different their entries are mapped to one another via flatVectorView(). This will recursive enumerate the entries of the types in lexicographic order (unless flatVectorView is specialized differently for a certain type).

As a consequence the nodal range entry is required to have a total dimension dim_RE = dim_C * dim_V and to be compatible with flatVectorView().

Template Parameters

  B | Type of global basis
  V | Type of coefficient vectors
  NTRE | Type of node-to-range-entry-map that associates each leaf node in the local ansatz subtree with an entry in the range type
  R | Range type of this function

Requirements:

- Type R is default constructible
- default constructed R has correct "shape" to hold the components of the range and to be accessible using the node-to-range-entry map NTRE.
- This requirements applies recursively to the derivative ranges.

## Member Typedef Documentation

## Basis

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

using Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >::Basis = typename Base::Basis

## Coefficient

using Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::Coefficient

inherited

## Domain

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

using Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >::Domain = typename Base::Domain

## Element

using Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::Element

inherited

## EntitySet

using Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::EntitySet

inherited

## GridView

using Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::GridView

inherited

## LocalDomain

using Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::LocalDomain

inherited

## NodeToRangeEntry

using Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::NodeToRangeEntry

inherited

## Range

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

using Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >::Range = R

## Traits

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

using Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >::Traits = Imp::GridFunctionTraits<Range(Domain), typename Base::EntitySet, DefaultDerivativeTraits, 16>

## Tree

using Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::Tree

inherited

## Vector

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

using Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >::Vector = typename Base::Vector

## Constructor & Destructor Documentation

## DiscreteGlobalBasisFunction() [1/2]

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>
template<class B_T, class V_T, class NTRE_T>

Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >::DiscreteGlobalBasisFunction | ( | B_T && | basis,
|  | V_T && | coefficients,
|  | NTRE_T && | nodeToRangeEntry )

inline

Create a grid-function, by wrapping the arguments in std::shared_ptr.

## DiscreteGlobalBasisFunction() [2/2]

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >::DiscreteGlobalBasisFunction | ( | std::shared_ptr< const Basis > | basis,
|  | std::shared_ptr< const V > | coefficients,
|  | std::shared_ptr< const typename Base::NodeToRangeEntry > | nodeToRangeEntry )

inline

Create a grid-function, by moving the arguments in std::shared_ptr.

## Member Function Documentation

## basis()

const Basis & Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::basis | ( |  | ) | const

inline inherited

Return a const reference to the stored basis.

## dofs()

const Vector & Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::dofs | ( |  | ) | const

inline inherited

Return the coefficients of this discrete function by reference.

## entitySet()

const EntitySet & Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::entitySet | ( |  | ) | const

inline inherited

Get associated set of entities the local-function can be bound to.

## nodeToRangeEntry()

const NodeToRangeEntry & Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::nodeToRangeEntry | ( |  | ) | const

inline inherited

Return the stored node-to-range map.

## operator()()

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

Range Dune::Functions::DiscreteGlobalBasisFunction< B, V, NTRE, R >::operator() | ( | const Domain & | x | ) | const

inline

Evaluate at a point given in world coordinates.

Warning
  This has to find the element that the evaluation point is in. It is therefore very slow.

## Friends And Related Symbol Documentation

## derivative

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

DiscreteGlobalBasisFunctionDerivative< DiscreteGlobalBasisFunction > derivative | ( | const DiscreteGlobalBasisFunction< B, V, NTRE, R > & | f | ) |

friend

Derivative of the DiscreteGlobalBasisFunction.

## localFunction

template<typename B, typename V, typename NTRE = HierarchicNodeToRangeMap, typename R = typename V::value_type>

LocalFunction localFunction | ( | const DiscreteGlobalBasisFunction< B, V, NTRE, R > & | t | ) |

friend

Construct local function from a DiscreteGlobalBasisFunction.

The obtained local function satisfies the concept Dune::Functions::Concept::LocalFunction. It must be bound to an entity from the entity set of the DiscreteGlobalBasisFunction before it can be used.

## Member Data Documentation

## data_

std::shared_ptr<const Data> Dune::Functions::ImplDoc::DiscreteGlobalBasisFunctionBase< B, V, HierarchicNodeToRangeMap >::data_

protected inherited

The documentation for this class was generated from the following file:

- discreteglobalbasisfunction.hh